dhtmlXForm.prototype.items.tinymce = {
	
	render: function(item, data) {
		
		item._type = "tinymce";
		item._enabled = true;
		item._tinyId = "tinymce_"+window.dhx4.newId();
		
		this.doAddLabel(item, data);
		this.doAddInput(item, data, "TEXTAREA", null, true, true, "dhxform_textarea");
		
		item.childNodes[item._ll?1:0].childNodes[0].rows = (Number(data.rows)||5)+(window.dhx4.isIE6?1:0);
		item.childNodes[item._ll?1:0].childNodes[0].id = item._tinyId;
		
		tinymce.init({
			selector: "#"+item._tinyId,
			init_instance_callback: function(editor){
				editor.on("change", function(){
					item._value = this.getContent();
					if (!item._unloading) item.getForm().callEvent("onChange", [item._idd, item._value]);
				});
			}
		});
		
		this.setValue(item, data.value);
		
		return this;
	},
	
	setValue: function(item, value) {
		tinymce.get(item._tinyId).setContent(value);
		item._value = value;
	},
	
	getValue: function(item) {
		item._value = tinymce.get(item._tinyId).getContent();
		return item._value;
	},
	
	destruct: function(item) {
		item._unloading = true;
		tinymce.get(item._tinyId).remove();
		this.d2(item);
		item = null;
	},
	
	enable: function(item) {
		item._is_enabled = true;
	},
	
	disable: function(item) {
		item._is_enabled = false;
	},
	
	setFocus: function() {
		tinymce.get(item._tinyId).focus();
	}
};

(function(){
	for (var a in {doAddLabel:1,doAddInput:1,setText:1,getText:1,isEnabled:1,doUnloadNestedLists:1})
		dhtmlXForm.prototype.items.tinymce[a] = dhtmlXForm.prototype.items.input[a];
})();

dhtmlXForm.prototype.items.tinymce.d2 = dhtmlXForm.prototype.items.input.destruct;

dhtmlXForm.prototype.setFormData_tinymce = function(name, value) {
	return this.doWithItem(name, "setValue", value);
};

dhtmlXForm.prototype.getFormData_tinymce = function(name) {
	return this.doWithItem(name, "getValue");
};
